/*   -*- buffer-read-only: t -*- vi: set ro:
 *  
 *  DO NOT EDIT THIS FILE   (opts.h)
 *  
 *  It has been AutoGen-ed  Tuesday May 14, 2002 at 10:12:30 AM BST
 *  From the definitions    ./opts.def
 *  and the template file   options
 */
/*
 *  This file contains the programmatic interface to the Automated
 *  Options generated for the getdefs program.
 *  These macros are documented in the AutoGen info file in the
 *  "AutoOpts" chapter.  Please refer to that doc for usage help.
 */
#ifndef AUTOOPTS_OPTS_H_GUARD
#define AUTOOPTS_OPTS_H_GUARD

/*
 * getdefs copyright 1999-2001 Bruce Korb - all rights reserved
 *
 * getdefs is free software.
 * 
 * You may redistribute it and/or modify it under the terms of the
 * GNU General Public License, as published by the Free Software
 * Foundation; either version 2, or (at your option) any later version.
 * 
 * getdefs is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with getdefs.  See the file "COPYING".  If not,
 * write to:  The Free Software Foundation, Inc.,
 *            59 Temple Place - Suite 330,
 *            Boston,  MA  02111-1307, USA.
 */
#include <options.h>

/*
 *  Enumeration of each option:
 */
typedef enum {
        INDEX_OPT_DEFS_TO_GET      =  0,
        INDEX_OPT_ORDERING         =  1,
        INDEX_OPT_FIRST_INDEX      =  2,
        INDEX_OPT_INPUT            =  3,
        INDEX_OPT_SUBBLOCK         =  4,
        INDEX_OPT_LISTATTR         =  5,
        INDEX_OPT_FILELIST         =  6,
        INDEX_OPT_ASSIGN           =  8,
        INDEX_OPT_COMMON_ASSIGN    =  9,
        INDEX_OPT_COPY             = 10,
        INDEX_OPT_SRCFILE          = 11,
        INDEX_OPT_LINENUM          = 12,
        INDEX_OPT_OUTPUT           = 14,
        INDEX_OPT_AUTOGEN          = 15,
        INDEX_OPT_TEMPLATE         = 16,
        INDEX_OPT_AGARG            = 17,
        INDEX_OPT_BASE_NAME        = 18,
        INDEX_OPT_VERSION          = 19,
        INDEX_OPT_HELP             = 20,
        INDEX_OPT_MORE_HELP        = 21,
        INDEX_OPT_SAVE_OPTS        = 22,
        INDEX_OPT_LOAD_OPTS        = 23
} teOptIndex;

#define OPTION_CT    24
#define GETDEFS_VERSION       "1.3"
#define GETDEFS_FULL_VERSION  "getdefs - AutoGen Definition Extraction Tool - Ver. 1.3"

/*
 *  Interface defines for all options.  Replace "n" with
 *  the UPPER_CASED option name (as in the teOptIndex
 *  enumeration above).  e.g. HAVE_OPT( DEFS_TO_GET )
 */
#ifdef __STDC__
#define     DESC(n)     getdefsOptions.pOptDesc[INDEX_OPT_ ## n]
#else
#define     DESC(n)     getdefsOptions.pOptDesc[INDEX_OPT_/**/n]
#endif
#define     HAVE_OPT(n) (! UNUSED_OPT(&DESC(n)))
#define      OPT_ARG(n) (DESC(n).pzLastArg)
#define    STATE_OPT(n) (DESC(n).fOptState & OPTST_SET_MASK)
#define    COUNT_OPT(n) (DESC(n).optOccCt)
#define    ISSEL_OPT(n) (SELECTED_OPT(&DESC(n)))
#define ISUNUSED_OPT(n) (UNUSED_OPT(& DESC(n)))
#define  ENABLED_OPT(n) (! DISABLED_OPT(& DESC(n)))
#define  STACKCT_OPT(n) (((tArgList*)(DESC(n).optCookie))->useCt)
#define STACKLST_OPT(n) (((tArgList*)(DESC(n).optCookie))->apzArgs)
#define    CLEAR_OPT(n) STMTS( \
                DESC(n).fOptState &= OPTST_PERSISTENT;   \
                if ( (DESC(n).fOptState & OPTST_INITENABLED) == 0) \
                    DESC(n).fOptState |= OPTST_DISABLED; \
                DESC(n).optCookie = NULL )

/*
 *  Interface defines for specific options.
 */
#define VALUE_OPT_DEFS_TO_GET    0
#define VALUE_OPT_ORDERING       1
#define VALUE_OPT_FIRST_INDEX    2
#define OPT_VALUE_FIRST_INDEX    (*(long*)(&OPT_ARG(FIRST_INDEX)))
#define VALUE_OPT_INPUT          3
#define SET_OPT_INPUT(a)   STMTS( \
        DESC(INPUT).optActualIndex = 3; \
        DESC(INPUT).optActualValue = VALUE_OPT_INPUT; \
        DESC(INPUT).fOptState &= OPTST_PERSISTENT; \
        DESC(INPUT).fOptState |= OPTST_SET; \
        DESC(INPUT).pzLastArg  = (char*)(a); \
        (*(DESC(INPUT).pOptProc))( &getdefsOptions, \
                getdefsOptions.pOptDesc + 3 ) )
#define VALUE_OPT_SUBBLOCK       4
#define VALUE_OPT_LISTATTR       5
#define VALUE_OPT_FILELIST       6
#define VALUE_OPT_ASSIGN         8
#define VALUE_OPT_COMMON_ASSIGN  9
#define VALUE_OPT_COPY           10
#define VALUE_OPT_SRCFILE        11
#define VALUE_OPT_LINENUM        12
#define VALUE_OPT_OUTPUT         14
#define VALUE_OPT_AUTOGEN        15
#define WHICH_OPT_AUTOGEN        (DESC(AUTOGEN).optActualValue)
#define WHICH_IDX_AUTOGEN        (DESC(AUTOGEN).optActualIndex)
#define VALUE_OPT_TEMPLATE       16
#define VALUE_OPT_AGARG          17
#define VALUE_OPT_BASE_NAME      18

#define VALUE_OPT_VERSION        INDEX_OPT_VERSION
#define VALUE_OPT_SAVE_OPTS      INDEX_OPT_SAVE_OPTS
#define VALUE_OPT_LOAD_OPTS      INDEX_OPT_LOAD_OPTS
#define VALUE_OPT_HELP           INDEX_OPT_HELP
#define VALUE_OPT_MORE_HELP      INDEX_OPT_MORE_HELP
#define SET_OPT_SAVE_OPTS(a)   STMTS( \
        DESC(SAVE_OPTS).fOptState &= OPTST_PERSISTENT; \
        DESC(SAVE_OPTS).fOptState |= OPTST_SET; \
        DESC(SAVE_OPTS).pzLastArg  = (char*)(a) )

/*
 *  Interface defines not associated with particular options
 */
#define  ERRSKIP_OPTERR STMTS( getdefsOptions.fOptSet &= ~OPTPROC_ERRSTOP )
#define  ERRSTOP_OPTERR STMTS( getdefsOptions.fOptSet |= OPTPROC_ERRSTOP )
#define  RESTART_OPT(n) STMTS( \
                getdefsOptions.curOptIdx = (n); \
                getdefsOptions.pzCurOpt  = NULL )
#define    START_OPT    RESTART_OPT(1)
#define     USAGE(c)    (*getdefsOptions.pUsageProc)( &getdefsOptions, c )

/* * * * * *
 *
 *  Declare the getdefs option descriptor.
 */
#ifdef  __cplusplus
extern "C" {
#endif

extern tOptions   getdefsOptions;

#ifdef  __cplusplus
}
#endif
#endif /* AUTOOPTS_OPTS_H_GUARD */
